<?php
/* #############################################
####### OBTENER CODIGO HTML BY: AEX12 ##########
##############################################*/

/*
function obtenerhtml($url){
	$codigohtml="";
	$fo= fopen("$url","r") or die ("No se ha encontrado la pagina.");
	while (!feof($fo)) {
		$codigohtml .= fgets($fo, 4096);
	}
	fclose ($fo);
	return $codigohtml;
}
*/


function obtenerhtml($url){
	$texto = file_get_contents($url);
	return $texto;
}


function completar_cero_cantidades($xcantidad){
	if(strlen($xcantidad)==1){
		$xcantidad = "0".$xcantidad;
	}
		
	return $xcantidad;
}


function completar_cero_cantidades2($xcantidad){

	if(strlen($xcantidad)==1){
		$xcantidad = "00".$xcantidad;
	}

	if(strlen($xcantidad)==2){
		$xcantidad = "0".$xcantidad;
	}
		
	return $xcantidad;
}



function calcular_saldo_a_favor($xid, $conexion){

	$ximporte_pedido=0;
	$r_importe_pedido=mysqli_query($conexion,"SELECT sum(ordpeddet_precio * ordpeddet_cantidad) AS importe_pedido FROM orden_pedido_detalle o WHERE ordped_codi_fk=$xid;");
	while($row_importe_pedido=mysqli_fetch_array($r_importe_pedido)){
		$ximporte_pedido =  $row_importe_pedido['importe_pedido']; 		
	}


	$ximporte_pagado=0;
	$r_importe_pagado=mysqli_query($conexion,"SELECT sum(opecaj_monto) as importe_pagado FROM operacion_caja o LEFT JOIN orden_pedido_caja opc ON opc.opecaj_codi_fk=o.opecaj_codi WHERE opc.ordped_codi_fk=$xid and opecaj_estado=1;");
	while($row_importe_pagado=mysqli_fetch_array($r_importe_pagado)){
		$ximporte_pagado =  $row_importe_pagado['importe_pagado']; 		
	}
		  

	$xsaldo_a_favor=0;
	$xmonto_total=0;
	
	$r_detalle_bruto=mysqli_query($conexion,"SELECT prd_codi_fk, unimed_codi_fk, SUM(ordpeddet_cantidad) as cantidad_bruta FROM orden_pedido_detalle o WHERE o.ordped_codi_fk=$xid GROUP BY prd_codi_fk, unimed_codi_fk ORDER BY prd_codi_fk;");
	while($row_detalle_bruto = mysqli_fetch_array($r_detalle_bruto)){
		
		$xcantidad_bruta = $row_detalle_bruto['cantidad_bruta'];
		$xprd_codi_fk = $row_detalle_bruto['prd_codi_fk'];
		$xunimed_codi_fk = $row_detalle_bruto['unimed_codi_fk'];		
		
		?>			
		<script language="javascript">
	//	alert(" cantidad_bruta:  <?php echo $xcantidad_bruta; ?>");
		</script>			
		<?php
		
		$r_detalle_almacen=mysqli_query($conexion,"SELECT prd_codi_fk, unimed_codi_fk, sum(oad.opealmdet_cantidad) AS cantidad FROM orden_pedido_almacen o INNER JOIN operacion_almacen oa ON o.opealm_codi_fk=oa.opealm_codi INNER JOIN operacion_almacen_detalle oad ON o.opealm_codi_fk=oad.opealm_codi_fk WHERE oa.opealm_estado=1 AND ordped_codi_fk=$xid AND oad.prd_codi_fk=$xprd_codi_fk AND  oad.unimed_codi_fk=$xunimed_codi_fk GROUP BY oad.prd_codi_fk, oad.unimed_codi_fk;");
				
		if(mysqli_num_rows($r_detalle_almacen)>0){
		
			while($row_detalle_almacen = mysqli_fetch_array($r_detalle_almacen)){
						
				$xcantidad = $row_detalle_almacen['cantidad'];
				//$xprd_codi_fk = $row_detalle_almacen['prd_codi_fk'];
				//$xunimed_codi_fk = $row_detalle_almacen['unimed_codi_fk'];
				
				?>			
				<script language="javascript">
			//	alert(" cantidad:  <?php echo $xcantidad; ?>");
				</script>			
				<?php
				
		
				$xmonto=0;
				$r_detalle_pedido=mysqli_query($conexion,"SELECT * FROM orden_pedido_detalle o 
														WHERE o.ordped_codi_fk=$xid 
														AND o.prd_codi_fk=$xprd_codi_fk 
														AND o.unimed_codi_fk=$xunimed_codi_fk 
														ORDER BY ordpeddet_precio desc;");
				while($row_detalle_pedido = mysqli_fetch_array($r_detalle_pedido)){
			
					$xprd_codi_fk = $row_detalle_pedido['prd_codi_fk'];
					$xunimed_codi_fk = $row_detalle_pedido['unimed_codi_fk'];
					$xordpeddet_precio = $row_detalle_pedido['ordpeddet_precio'];
					$xordpeddet_cantidad = $row_detalle_pedido['ordpeddet_cantidad'];		
					
					?>			
					<script language="javascript">
				//	alert(" pedidos:  <?php echo $xordpeddet_cantidad; ?>");
					</script>			
					<?php
					
						
					if($xordpeddet_cantidad <= $xcantidad){
						$xmonto = $xordpeddet_cantidad * $xordpeddet_precio;
						$xcantidad = $xcantidad - $xordpeddet_cantidad;
					}else{
						$xmonto = $xcantidad * $xordpeddet_precio;				
						$xcantidad = 0;				
					}		
								
					$xmonto_total = $xmonto_total + $xmonto;
					
				}			
					
				//$xsaldo_a_favor = $ximporte_pagado - $xmonto_total;	
				
				//return $xsaldo_a_favor;
				
			}
	
		}else{
	
			$xmonto=0;
			$xmonto_total = $xmonto_total + $xmonto;
	
		}
		
					
	
	}
	
	$xsaldo_a_favor = $ximporte_pagado - $xmonto_total;	
	$xdeuda = $ximporte_pedido - $ximporte_pagado;

	?>			
	<script language="javascript">
	//alert("xdeuda:  <?php echo $xdeuda; ?>  importe_pedido:  <?php echo $ximporte_pedido; ?>  importe_pagada:  <?php echo $ximporte_pagado; ?>");
	</script>			
	<?php

	
	if($xdeuda <= 0.01 ){
	
	}else{
		//return $xsaldo_a_favor;
		return $xsaldo_a_favor;
	}	
	
}





function obtenermes($xfecha){
	
	$nmes = date('m',strtotime($xfecha));
	
	switch ($nmes) {
    case '01':
        $tmes = "ENERO";
        break;
    case '02':
        $tmes = "FEBRERO";
        break;
    case '03':
        $tmes = "MARZO";
        break;
    case '04':
        $tmes = "ABRIL";
        break;
    case '05':
        $tmes = "MAYO";
        break;
    case '06':
        $tmes = "JUNIO";
        break;
    case '07':
        $tmes = "JULIO";
        break;
    case '08':
        $tmes = "AGOSTO";
        break;
    case '09':
        $tmes = "SETIEMBRE";
        break;
    case '10':
        $tmes = "OCTUBRE";
        break;
    case '11':
        $tmes = "NOVIEMBRE";
        break;
    case '12':
        $tmes = "DICIEMBRE";
        break;

	}	
	
	return $tmes;	
}





/********/	
/*******INICIO REORGANIZACION DE PROMOCIONES*******/		
function organizar_promociones($conexion, $arr, $xprd_codi, $xunimed_codi){		
	echo "<br>";
	//$arr = $arr_cotizacion;
	$arr1 = array();
	$arr2 = array();
	$arr3 = array();			
			
	$z=0;
	$y=0;
	for($x=0; $x<count($arr,0); $x++){
		if(count($arr1,0) > 0){
			$add = 0;
			for($z=0; $z<count($arr1,0); $z++){		
				//if($arr1[$z]['codigo']==$arr[$x]['codigo']  and  $arr1[$z]['nombre']==$arr[$x]['nombre']){				
				if($arr1[$z]['t_prd_codi_fk'] == $arr[$x]['t_prd_codi_fk'] and 
		   		   $arr1[$z]['t_unimed_codi_fk'] == $arr[$x]['t_unimed_codi_fk']){ 
								
					$arr1[$z]['t_cantidad'] = $arr1[$z]['t_cantidad'] + $arr[$x]['t_cantidad'];
					$add = 1;
				}	
			}		
			if($add == 0){
				//$arr1[$y]['codigo'] = $arr[$x]['codigo'];
				//$arr1[$y]['nombre'] = $arr[$x]['nombre']; 
				//$arr1[$y]['cantidad'] = $arr[$x]['cantidad'];
				//$arr1[$y]['precio'] = $arr[$x]['precio'];
								
				$arr1[$y]['t_ordpeddet_fechahora'] = $arr[$x]['t_ordpeddet_fechahora'];
				$arr1[$y]['t_prd_codi_fk'] = $arr[$x]['t_prd_codi_fk'];
				$arr1[$y]['t_idtrans'] = $arr[$x]['t_idtrans'];
				$arr1[$y]['t_unimed_codi_fk'] = $arr[$x]['t_unimed_codi_fk'];
				$arr1[$y]['t_ordpeddet_precio'] = $arr[$x]['t_ordpeddet_precio'];
				$arr1[$y]['t_idtrans_temporal'] = $arr[$x]['t_idtrans_temporal'];
				$arr1[$y]['t_cantidad'] = $arr[$x]['t_cantidad'];
				$arr1[$y]['t_observacion'] = $arr[$x]['t_observacion'];	
				$arr1[$y]['t_ordped_codi'] = $arr[$x]['t_ordped_codi'];					
				$y = $y + 1;								
			}		
		}else{
			//$arr1[$y]['codigo'] = $arr[$x]['codigo'];
			//$arr1[$y]['nombre'] = $arr[$x]['nombre']; 
			//$arr1[$y]['cantidad'] = $arr[$x]['cantidad'];
			//$arr1[$y]['precio'] = $arr[$x]['precio'];
			
			$arr1[$y]['t_ordpeddet_fechahora'] = $arr[$x]['t_ordpeddet_fechahora'];
			$arr1[$y]['t_prd_codi_fk'] = $arr[$x]['t_prd_codi_fk'];
			$arr1[$y]['t_idtrans'] = $arr[$x]['t_idtrans'];
			$arr1[$y]['t_unimed_codi_fk'] = $arr[$x]['t_unimed_codi_fk'];
			$arr1[$y]['t_ordpeddet_precio'] = $arr[$x]['t_ordpeddet_precio'];
			$arr1[$y]['t_idtrans_temporal'] = $arr[$x]['t_idtrans_temporal'];
			$arr1[$y]['t_cantidad'] = $arr[$x]['t_cantidad'];
			$arr1[$y]['t_observacion'] = $arr[$x]['t_observacion'];	
			$arr1[$y]['t_ordped_codi'] = $arr[$x]['t_ordped_codi'];								
			$y = $y + 1;		
		}				
	}
	
	
	$arr = $arr1;
	$z = 0;
	$xfecha = date('Y-m-d');					
	for($x=0; $x<count($arr,0); $x++){
		//echo $arr[$x]['t_prd_codi_fk']." - ".$arr[$x]['t_unimed_codi_fk']." - ".$arr[$x]['t_cantidad']." - ".$arr[$x]['t_ordpeddet_precio'];
		
		$xt_prd_codi_fk = $arr[$x]['t_prd_codi_fk'];
		$xt_unimed_codi_fk = $arr[$x]['t_unimed_codi_fk'];
		$xt_cantidad = $arr[$x]['t_cantidad'];		
				
		if(){
		
		}					
		
		
		
		/****** VERIFICACION DE PROMOCIONES ******/
		$r_mayorista = mysqli_query($conexion,"SELECT prc_precio, mp_nombre, mp_cantidad FROM precios p
												INNER JOIN productos prd ON prd.prd_codi=p.prd_codi_fk
												INNER JOIN masterpack mp ON mp.mp_codi=prd.mp_codi_fk
												WHERE prctip_codi_fk = $xt_prd_codi_fk
												AND prd_codi_fk = $xt_unimed_codi_fk;");
		while($row_mayorista = mysqli_fetch_array($r_mayorista)){
			$xprc_precio = $row_mayorista['prc_precio'];
			$xmp_cantidad = $row_mayorista['mp_cantidad'];
		}																								
		/****** FIN VERIFICACION DE PROMOCIONES ******/
		
		
		
		
		/****** VERIFICACION DE PROMOCIONES ******/
		$xunimed_codi_fk = "";			
		$xprd_codi_fk = "";
		$xpromdet_cantidad = 0;
		$r_promocion = mysqli_query($conexion,"SELECT pd.unimed_codi_fk, pd.prd_codi_fk, pd.promdet_precio, pd.promdet_cantidad, pd.promdet_precio_promocion
												FROM promociones p
												INNER JOIN promociones_detalle pd ON pd.prom_codi_fk=p.prom_codi
												WHERE p.prom_codi=(
												SELECT pp.prom_codi
												FROM promociones pp
												INNER JOIN promociones_detalle ppdd ON ppdd.prom_codi_fk=pp.prom_codi
												WHERE pp.prom_estado = 1
												AND ((pp.prom_activado=1 AND pp.prom_fecha_inicio <= '$xfecha' AND pp.prom_fecha_fin >= '$xfecha') 
												OR (pp.prom_activado=0))
												AND ppdd.prd_codi_fk = $xt_prd_codi_fk
												AND ppdd.unimed_codi_fk = $xt_unimed_codi_fk
												ORDER BY pp.prom_codi DESC
												LIMIT 1);"); 
		while($row_promocion = mysqli_fetch_array($r_promocion)){
			$xunimed_codi_fk = $row_promocion['unimed_codi_fk'];
			$xprd_codi_fk = $row_promocion['prd_codi_fk'];
			$xpromdet_cantidad = $row_promocion['promdet_cantidad'];
			$xpromdet_precio_promocion = $row_promocion['promdet_precio_promocion'];
			$xpromdet_precio = $row_promocion['promdet_precio'];
			
			$xprecio_venta = 0;
			$r_precio_venta = mysqli_query($conexion,"SELECT p.prc_precio FROM precios p
													WHERE unimed_codi_fk = $xunimed_codi_fk
													AND prd_codi_fk = $xprd_codi_fk
													AND prctip_codi_fk = 2
													AND prc_estado = 1;");
			while($row_precio_venta = mysqli_fetch_array($r_precio_venta)){
				$xprecio_venta = $row_precio_venta['prc_precio'];
			}													
		}
		/****** FIN VERIFICACION DE PROMOCIONES ******/
		
		
		
		if($arr[$x]['t_prd_codi_fk'] == $xprd_codi_fk and 
		   $arr[$x]['t_unimed_codi_fk'] == $xunimed_codi_fk and 
		   $arr[$x]['t_cantidad'] >= $xpromdet_cantidad ){ 
							
			$xentero = intval($arr[$x]['t_cantidad'] / $xpromdet_cantidad);
			
			$xcantidad_oferta = $xentero * $xpromdet_cantidad;
			$xcantidad_excluida = $arr[$x]['t_cantidad'] - $xcantidad_oferta;
			
			//echo " (cantidad_oferta: ".$xcantidad_oferta.") ";		
			//echo " (xcantidad_excluida: ".$xcantidad_excluida.") ";					
			//echo " (oferta) ";
			
			
			//$arr2[$x]['codigo'] = $arr[$x]['codigo'];
			//$arr2[$x]['nombre'] = $arr[$x]['nombre']; 
			//$arr2[$x]['cantidad'] = $xcantidad_oferta;
			////$arr2[$x]['precio'] = $precio_afectado;	
			//$arr2[$x]['precio'] = $precio_afectado[$arr[$x]['codigo']];	
			
			
			$arr2[$x]['t_ordpeddet_fechahora'] =$arr[$x]['t_ordpeddet_fechahora'];
			$arr2[$x]['t_prd_codi_fk'] = $arr[$x]['t_prd_codi_fk'];
			$arr2[$x]['t_idtrans'] = $arr[$x]['t_idtrans'];
			$arr2[$x]['t_unimed_codi_fk'] = $arr[$x]['t_unimed_codi_fk'];
			$arr2[$x]['t_ordpeddet_precio'] = $xpromdet_precio_promocion;
			$arr2[$x]['t_idtrans_temporal'] = $arr[$x]['t_idtrans_temporal'];
			$arr2[$x]['t_cantidad'] = $xcantidad_oferta;
			$arr2[$x]['t_observacion'] = $arr[$x]['t_observacion'];	
			$arr2[$x]['t_ordped_codi'] = $arr[$x]['t_ordped_codi'];						
								
			if($xcantidad_excluida > 0){			
				
				//$arr3[$z]['codigo'] = $arr[$x]['codigo'];
				//$arr3[$z]['nombre'] = $arr[$x]['nombre']; 
				//$arr3[$z]['cantidad'] = $xcantidad_excluida;
				//$arr3[$z]['precio'] = $arr[$x]['precio'];
				
				$arr3[$z]['t_ordpeddet_fechahora'] =$arr[$x]['t_ordpeddet_fechahora'];
				$arr3[$z]['t_prd_codi_fk'] = $arr[$x]['t_prd_codi_fk'];
				$arr3[$z]['t_idtrans'] = $arr[$x]['t_idtrans'];
				$arr3[$z]['t_unimed_codi_fk'] = $arr[$x]['t_unimed_codi_fk'];
				//$arr3[$z]['t_ordpeddet_precio'] = $arr[$x]['t_ordpeddet_precio'];						
				//$arr3[$z]['t_ordpeddet_precio'] = $xpromdet_precio;
				$arr3[$z]['t_ordpeddet_precio'] = $xprecio_venta;
				$arr3[$z]['t_idtrans_temporal'] = $arr[$x]['t_idtrans_temporal'];
				$arr3[$z]['t_cantidad'] = $xcantidad_excluida;
				$arr3[$z]['t_observacion'] = $arr[$x]['t_observacion'];	
				$arr3[$z]['t_ordped_codi'] = $arr[$x]['t_ordped_codi'];						
																		
				$z = $z + 1;			
			}	
		}else{		
			
			//$arr2[$x]['codigo'] = $arr[$x]['codigo'];
			//$arr2[$x]['nombre'] = $arr[$x]['nombre']; 
			//$arr2[$x]['cantidad'] = $arr[$x]['cantidad'];
			//$arr2[$x]['precio'] = $arr[$x]['precio'];
			
			
			//$arr[$x]['t_prd_codi_fk'] == $xprd_codi_fk and 
			//$arr[$x]['t_unimed_codi_fk'] == $xunimed_codi_fk and 
			//$arr[$x]['t_cantidad'] >= $xpromdet_cantidad
			
			//echo "<br>";
			//echo $arr2[$x]['t_prd_codi_fk'];
			//echo "<br>";					
			
			if($arr2[$x]['t_prd_codi_fk'] == $xprd_codi and 
				$arr2[$x]['t_unimed_codi_fk'] == $xunimed_codi){	
				
				//echo "<br>";
				//echo "CUMPLIENDO!!!";			   
				
				//$arr[$x]['t_cantidad'] = $arr[$x]['t_cantidad'] + 1;
				//$salta = 1;
				//$_SESSION['arr_cotizacion'] = $arr_cotizacion;						
				//break;
			}else{						
			
				//echo "<br>";
				//echo "OJO!!!";	
			
				$arr2[$x]['t_ordpeddet_fechahora'] =$arr[$x]['t_ordpeddet_fechahora'];
				$arr2[$x]['t_prd_codi_fk'] = $arr[$x]['t_prd_codi_fk'];
				$arr2[$x]['t_idtrans'] = $arr[$x]['t_idtrans'];
				$arr2[$x]['t_unimed_codi_fk'] = $arr[$x]['t_unimed_codi_fk'];
				$arr2[$x]['t_ordpeddet_precio'] = $arr[$x]['t_ordpeddet_precio'];
				$arr2[$x]['t_idtrans_temporal'] = $arr[$x]['t_idtrans_temporal'];
				$arr2[$x]['t_cantidad'] = $arr[$x]['t_cantidad'];
				$arr2[$x]['t_observacion'] = $arr[$x]['t_observacion'];	
				$arr2[$x]['t_ordped_codi'] = $arr[$x]['t_ordped_codi'];																
			}
		}				
	}
	
	
	$arr4 = array_merge($arr2, $arr3);	
	//usort($arr4, 'sort_by_orden');
	//function sort_by_orden ($a, $b) {
    //	return $a['t_prd_codi_fk'] - $b['t_prd_codi_fk'];
	//}	
	
	$arr_cotizacion = $arr4;
	$_SESSION['arr_cotizacion'] = $arr_cotizacion;
	
	return $arr_cotizacion;
}					
	
/*******FIN REORGANIZACION DE PROMOCIONES*******/
/********/			







?>